Bug 903396 - Tracker for gluster-swift refactoring work (PDQ)
Tracker for gluster-swift refactoring work (PDQ)
Status: CLOSED EOL
Product: GlusterFS
Classification: Community
Component: object-storage (Show other bugs)
mainline
x86_64 Linux
high Severity high
: ---
: ---
Assigned To: Luis Pabón
: Tracking
: 978061 (view as bug list)
Depends On: 865619 865858 865926 868086 868120 894674 904370 904629 911443 911446 821310 827410 844805 858413 865867 885281 890348 907072 911448 928919 951661
Blocks: 956991 978061
  Show dependency treegraph
 
Reported: 2013-01-23 16:52 EST by Peter Portante
Modified: 2015-10-22 11:46 EDT (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
: 978061 (view as bug list)
Environment:
Last Closed: 2015-10-22 11:46:38 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Knowledge Base (Solution) 158823 None None None Never

  None (edit)
Description Peter Portante 2013-01-23 16:52:47 EST
The UFO code, include some code in Openstack Swift proper, end up invoking a number of system calls that are not necessary, adding unnecessary load to the system and/or hampering performance for both small and large object transfers.

In some cases, this results in severe behaviors where GlusterFS becomes unavailable or crashes. In other cases, performance degrades to the point where it is not usable (60+ seconds to fulfill a request).

A first pass analysis of the system calls being made needs to be done to track down where they originate and remove the code the is responsible for any unwanted invocations.
Comment 1 Vijay Bellur 2013-03-07 00:08:51 EST
CHANGE: http://review.gluster.org/4641 (storage/posix: Remove a redundant lstat in posix_handle_hard.) merged in master by Anand Avati (avati@redhat.com)
Comment 2 Anand Avati 2013-04-07 22:26:35 EDT
REVIEW: http://review.gluster.org/4787 (object-storage: turn off stat() for container list) posted (#1) for review on master by Mohammed Junaid (junaid@redhat.com)
Comment 3 Anand Avati 2013-04-12 03:08:13 EDT
REVIEW: http://review.gluster.org/4787 (object-storage: turn off stat() for container list) posted (#2) for review on master by Mohammed Junaid (junaid@redhat.com)
Comment 4 Peter Portante 2013-04-12 14:43:01 EDT
This issue is not blocked by a RHEL 6 issue for running out of inodes (#928377) for two reasons:

 1. Does not seem right for an upstream patch to be blocked by a downstream
    issue

 2. The actions taken for running out inodes in Gluster, given the state of
    #928377, are no longer needed
Comment 5 Anand Avati 2013-04-12 16:49:12 EDT
COMMIT: http://review.gluster.org/4787 committed in master by Anand Avati (avati@redhat.com) 
------
commit bbaa273468f8e5377027aedcabcaa076dd7fec7e
Author: Mohammed Junaid <junaid@redhat.com>
Date:   Sun Apr 7 06:05:56 2013 +0530

    object-storage: turn off stat() for container list
    
    Turn of stat() system calls used to fetch the file size during a
    container listing operation since these system calls can swamp Gluster
    and the result is most often not used.
    
    When a GET or HEAD request is made on a container, stat() system calls
    are made during the Python standard library method, os.walk, to
    determine if a given directory entry is another directory to recurse
    into, and then utils._update_list() will stat() each file to get it
    size, and finally utils.get_container_details_from_fs() will stat()
    each directory encountered.
    
    For most installations we have seen so far, we don't need the
    container listing to accurately return the size of all the objects in
    the container, so we can reduce the number of stat() system calls by
    not fetching the size of the object.
    
    For now, turn it off by default, and provide an /etc/swift/fs.conf
    configuration parameter to turn it back on:
    
      accurate_size_in_listing = yes
    
    The default for the above is "no".
    
    Change-Id: I7dde11e14bb32ecafa3eabb08852f1ffc4366b35
    BUG: 903396
    Signed-off-by: Mohammed Junaid <junaid@redhat.com>
    Reviewed-on: http://review.gluster.org/4787
    Tested-by: Gluster Build System <jenkins@build.gluster.com>
    Reviewed-by: Kaleb KEITHLEY <kkeithle@redhat.com>
    Reviewed-by: Anand Avati <avati@redhat.com>
Comment 6 Anand Avati 2013-04-19 14:17:34 EDT
REVIEW: http://review.gluster.org/4859 (object-storage: remove stat of directories) posted (#1) for review on master by Mohammed Junaid (junaid@redhat.com)
Comment 7 Luis Pabón 2013-08-02 10:56:00 EDT
*** Bug 978061 has been marked as a duplicate of this bug. ***
Comment 8 Kaleb KEITHLEY 2015-10-22 11:46:38 EDT
because of the large number of bugs filed against mainline version\ is ambiguous and about to be removed as a choice.

If you believe this is still a bug, please change the status back to NEW and choose the appropriate, applicable version for it.

Note You need to log in before you can comment on or make changes to this bug.